
#include<Arduino.h>
//#include <ESP8266WiFi.h>
#include <ESP8266WebServer.h>
//#include <WiFiClient.h>
//#include <ESP8266mDNS.h>
#include <Wire.h>
#include <U8g2lib.h>

U8G2_SSD1306_128X64_NONAME_F_SW_I2C
u8g2(U8G2_R0, /* clock=*/ 12, /* data=*/ 14, /* reset=*/ U8X8_PIN_NONE);   // All Boards without Reset of the Display

const int buttonPin1 = 13;     // the number of the pushbutton pin
const int buttonPin2 = 15;
int audio8 = 2;      // output audio
int note = 800;      // music note/pitch
int led1 = 4;
int led2 = 5;
int led3 = 0;
int treshold = 300;
int buttonState1 = 0;
int buttonState2 = 0;
String alarmon1;
String alarmoff1;
String alarmon2;
String alarmoff2;
float t;

/*Put your SSID & Password*/
const char* ssid = "nome della tua rete wifi";
const char* password = "password della tua rete wifi";

ESP8266WebServer server(80);

void setup() {
  Serial.begin(115200);
  u8g2.begin();
  pinMode(buttonPin1, INPUT);
  pinMode(buttonPin2, INPUT);
  pinMode(led1, OUTPUT);
  pinMode(led2, OUTPUT);
  pinMode(led3, OUTPUT);
  delay(100);

  Serial.println("Connecting to ");
  Serial.println(ssid);

  WiFi.begin(ssid, password);

  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println("");
  Serial.println("WiFi connected..!");
  Serial.print("Got IP: ");  Serial.println(WiFi.localIP());

  server.on("/", handle_OnConnect);
  server.onNotFound(handle_NotFound);

  server.begin();
  Serial.println("HTTP server started");
}

void loop() {
  server.handleClient();
}

void handle_OnConnect() {
  server.send(200, "text/html", SendHTML(t));
  u8g2.clearBuffer();
  u8g2.setFont(u8g2_font_7x14B_tr);
  u8g2.drawStr(5, 10, "IP:");
  u8g2.drawStr(30, 10, WiFi.localIP().toString().c_str());

  buttonState1 = digitalRead(buttonPin1);
  buttonState2 = digitalRead(buttonPin2);

  if (buttonState1 == 1) {
    digitalWrite(led1, HIGH);
    Serial.println("Porta 1 chiusa");
    u8g2.drawStr(0, 30, "Porta 1 chiusa   ");
    alarmoff1 = "Porta di ingresso chiusa";
    alarmon1 = "                          ";
  } else {
    digitalWrite(led1, LOW);
    Serial.println("PORTA 1 APERTA");
    u8g2.drawStr(0, 30, "PORTA 1 APERTA!!!");
    alarmon1 = "PORTA DI INGRESSO APERTA!!!";
    alarmoff1 = "                           ";
  }

  if (buttonState2 == 1) {
    digitalWrite(led3, HIGH);
    Serial.println("Porta 2 chiusa");
    u8g2.drawStr(0, 50, "Porta 2 chiusa   ");
    u8g2.sendBuffer();
    alarmoff2 = "Porta-finestra chiusa";
    alarmon2 = "                     ";
  } else {
    digitalWrite(led3, LOW);
    Serial.println("PORTA 2 APERTA");
    u8g2.drawStr(0, 50, "PORTA 2 APERTA!!!");
    u8g2.sendBuffer();
    alarmon2 = "PORTA-FINESTRA APERTA!!!";
    alarmoff2 = "                        ";
  }

  if ((buttonState1 < 1) || (buttonState2 < 1)) {
    digitalWrite(led2, HIGH);
    tone(audio8, note);
  } else {
    digitalWrite(led2, LOW);
    noTone(audio8);
  }
  //Serial.println(buttonState1);
  //Serial.println(buttonState2);
  //delay(300);
}

void handle_NotFound() {
  server.send(404, "text/plain", "Not found");
}
String SendHTML(float t) {
  String ptr = "<!DOCTYPE html> <html>\n";
  ptr += "<head><meta http-equiv=\"refresh\" content=\"2\">\n";
  ptr += "<title>ESP8266 Weather Station</title>\n";
  ptr += "<style>html { font-family: Helvetica; display: inline-block; margin: 0px auto; text-align: center;}\n";
  ptr += "body{margin-top: 50px;} h1 {color: #000099;margin: 50px auto 30px;}\n";
  ptr += "p {font-size: 24px;color: #33cc00;margin-bottom: 10px;}\n";
  ptr += "t {font-size: 30px;color: #ff0000;margin-bottom: 10px;}\n";
  ptr += "</style>\n";
  ptr += "</head>\n";
  ptr += "<body>\n";
  ptr += "<div id=\"webpage\">\n";
  ptr += "<h1>Controllo porte di casa</h1>\n";
  ptr += "<p>";
  ptr += alarmoff1;
  ptr += "<p/> ";
  ptr += "<t>";
  ptr += alarmon1;
  ptr += "<t/> ";
  ptr += "<p>.";
  ptr += "<p/>";
  ptr += "<p> ";
  ptr += alarmoff2;
  ptr += "<p/> ";
  ptr += "<t>";
  ptr += alarmon2;
  ptr += "<t/> ";
  ptr += "</div>\n";
  ptr += "</body>\n";
  ptr += "</html>\n";
  return ptr;
}
